#include "mpi.h"

#define BAD_ANSWER 100000

int assoc(invec, inoutvec, len)
int *invec, *inoutvec, len;
{
  int i;
  for ( i=0; i<len; i++ )  {
    if (inoutvec[i] > invec[i] )
      inoutvec[i] = BAD_ANSWER;
    else 
      inoutvec[i] = invec[i];
  }
  return (1);
}

worker( argc, argv )
int argc;
char **argv;
{
    int              rank, size, i;
    MPI_Comm_request handle;
    MPI_Status       status;
    int              data;
    int              errors=0;
    int              result = -100;
    int              correct_result;

    MPI_Init( &argc, argv );
    MPI_Comm_rank( MPI_COMM_WORLD, &rank );
    MPI_Comm_size( MPI_COMM_WORLD, &size );

    data = rank;

    MPI_User_reducea ( &data, &result, 1, MPI_INT, assoc, size-1, MPI_COMM_WORLD );
    MPI_Bcast  ( &result, 1, MPI_INT, size-1, MPI_COMM_WORLD );
    if (result == BAD_ANSWER) errors++;

    MPI_Finalize();
    if (errors)
      printf( "[%d] done with ERRORS(%d)!\n", rank, errors );
    else
      printf( "[%d] SUCCESSFUL!\n", rank );
}
